package me.unurled.lymel.config;

import blue.endless.jankson.Jankson;
import io.wispforest.owo.config.ConfigWrapper;
import io.wispforest.owo.config.Option;
import io.wispforest.owo.util.Observable;

import java.util.HashMap;
import java.util.Map;
import java.util.function.Consumer;

public class LymelConfig extends ConfigWrapper<me.unurled.lymel.config.ConfigModel> {

    private final Option<java.lang.Boolean> useDB = this.optionForKey(new Option.Key("useDB"));

    private LymelConfig() {
        super(me.unurled.lymel.config.ConfigModel.class);
    }

    private LymelConfig(Consumer<Jankson.Builder> janksonBuilder) {
        super(me.unurled.lymel.config.ConfigModel.class, janksonBuilder);
    }

    public static LymelConfig createAndLoad() {
        var wrapper = new LymelConfig();
        wrapper.load();
        return wrapper;
    }

    public static LymelConfig createAndLoad(Consumer<Jankson.Builder> janksonBuilder) {
        var wrapper = new LymelConfig(janksonBuilder);
        wrapper.load();
        return wrapper;
    }

    public boolean useDB() {
        return useDB.value();
    }

    public void useDB(boolean value) {
        useDB.set(value);
    }




}

