package me.unurled.lymel;

import me.unurled.lymel.config.Config;
import me.unurled.lymel.managers.ModEvent;
import me.unurled.lymel.managers.ModItems;
import me.unurled.lymel.server.LymelServer;
import me.unurled.lymel.util.ConfigDataUtil;
import net.fabricmc.api.EnvType;
import net.fabricmc.api.ModInitializer;
import net.fabricmc.loader.api.FabricLoader;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import software.bernie.geckolib.GeckoLib;

import java.nio.file.Path;

public class Lymel implements ModInitializer {

    public static final String MODID = "lymel";
    public static Lymel INSTANCE;

    public static final Logger LOGGER = LoggerFactory.getLogger(MODID);

    private Config config = new Config();

    private LymelServer server;

    ModEvent modEvent;
    ModItems modItems;

    @Override
    public void onInitialize() {
        INSTANCE = this;
        GeckoLib.initialize();
        loadConfig();
        register();
        if (FabricLoader.getInstance().getEnvironmentType() == EnvType.SERVER) {
            server = new LymelServer();
            server.register(config);
        }
        LOGGER.info("Hallo from Lymel !");
    }

    private void loadConfig() {
        Path configPath = FabricLoader.getInstance().getConfigDir().resolve("Lymel/lymel.json");
        config = ConfigDataUtil.loadConfigData(Config.class, configPath);
    }

    private void saveConfig() {
        Path configPath = FabricLoader.getInstance().getConfigDir().resolve("Lymel/lymel.json");
        ConfigDataUtil.saveConfigData(Config.class, configPath.toFile(), config);
    }

    private void register() {
        modEvent = new ModEvent();
        modItems = new ModItems();
    }

    public LymelServer getServer() {
        return server;
    }
}
