package me.unurled.lymel.components.entity;

import dev.onyxstudios.cca.api.v3.component.ComponentKey;
import dev.onyxstudios.cca.api.v3.component.ComponentRegistryV3;
import dev.onyxstudios.cca.api.v3.entity.EntityComponentFactoryRegistry;
import dev.onyxstudios.cca.api.v3.entity.EntityComponentInitializer;
import dev.onyxstudios.cca.api.v3.entity.RespawnCopyStrategy;
import net.minecraft.entity.player.PlayerEntity;
import net.minecraft.util.Identifier;

public class PlayerComponents implements EntityComponentInitializer {

    public static final ComponentKey<StatComponent> STATISTICS =
            ComponentRegistryV3.INSTANCE.getOrCreate(new Identifier("lymel:stats"), StatComponent.class);
    @Override
    public void registerEntityComponentFactories(EntityComponentFactoryRegistry registry) {
        registry.registerForPlayers(STATISTICS, StatisicsComponent::new, RespawnCopyStrategy.ALWAYS_COPY);
    }

    public static void speed(PlayerEntity e) {
        float speed = STATISTICS.get(e).getSpeed();
        e.getAbilities().setWalkSpeed(speed);
        e.getAbilities().setFlySpeed(speed);
    }

    public static void setEverything(PlayerEntity e, float speed) {
        STATISTICS.get(e).setSpeed(speed);
    }

    public static void setDefault(PlayerEntity player) {
        STATISTICS.get(player).setSpeed(1.0f);
    }
}
