package me.unurled.lymel.components.entity;

import dev.onyxstudios.cca.api.v3.component.sync.AutoSyncedComponent;
import net.minecraft.entity.Entity;
import net.minecraft.entity.player.PlayerEntity;
import net.minecraft.nbt.NbtCompound;

public class StatisicsComponent implements StatComponent, AutoSyncedComponent {

    private float speed = 1.0f;
    private final PlayerEntity provider;


    public StatisicsComponent(PlayerEntity provider) {
        this.provider = provider;
    }

    @Override
    public float getSpeed() {
        return this.speed;
    }

    /**
     * @param key 
     * @return
     */
    @Override
    public Object get(String key) {
        return switch (key) {
            case "speed" -> getSpeed();
            default -> null;
        };
    }

    @Override
    public void setSpeed(float speed) {
        this.speed = speed;
        PlayerComponents.STATISTICS.sync(this.provider);
    }

    /**
     * @param key
     * @param value
     */
    @Override
    public void set(String key, Object value) {
        switch (key) {
            case "speed" -> setSpeed((float) value);
        };
    }

    @Override
    public void readFromNbt(NbtCompound tag) {
        this.speed = tag.getFloat("speed");
    }

    @Override
    public void writeToNbt(NbtCompound tag) {
        tag.putFloat("speed", this.speed);
    }
}

