package me.unurled.lymel.components.events.player;

import net.fabricmc.fabric.api.event.Event;
import net.fabricmc.fabric.api.event.EventFactory;
import net.minecraft.entity.player.PlayerEntity;
import net.minecraft.network.ClientConnection;
import net.minecraft.server.PlayerManager;
import net.minecraft.server.network.ServerPlayerEntity;
import net.minecraft.util.ActionResult;

/**
 * Callback when a Player joins the server.
 * Upon return :
 *  -
 */
public interface JoinServerCallback {

    Event<JoinServerCallback> EVENT = EventFactory.createArrayBacked(JoinServerCallback.class,
            (listeners) -> (manager, connection, player) -> {
                for (JoinServerCallback listener : listeners) {
                    listener.join(manager, connection, player);
                }
                return ActionResult.SUCCESS;
            });

    ActionResult join(PlayerManager manager, ClientConnection connection, ServerPlayerEntity player);

}
