package me.unurled.lymel.managers;

import me.unurled.lymel.Lymel;
import me.unurled.lymel.components.items.weapon.CombatKnife;
import net.fabricmc.fabric.api.item.v1.FabricItemSettings;
import net.fabricmc.fabric.api.itemgroup.v1.FabricItemGroup;
import net.fabricmc.fabric.api.itemgroup.v1.ItemGroupEvents;
import net.minecraft.item.Item;
import net.minecraft.item.ItemGroup;
import net.minecraft.item.ItemStack;
import net.minecraft.registry.Registries;
import net.minecraft.registry.Registry;
import net.minecraft.util.Identifier;

public class ModItems {
    private static final Item LOGO_ITEM = Registry.register(Registries.ITEM, new Identifier(Lymel.MODID, "logo"),
            new Item(new FabricItemSettings()));

    private static final ItemGroup ITEM_GROUP = FabricItemGroup.builder(new Identifier(Lymel.MODID, "lymel"))
            .icon(() -> new ItemStack(LOGO_ITEM))
            .build();

    private static final CombatKnife COMBAT_KNIFE = Registry.register(Registries.ITEM, new Identifier(Lymel.MODID, "combat_knife"),
            new CombatKnife(new FabricItemSettings().maxCount(1)));

    public ModItems() {
         ItemGroupEvents.modifyEntriesEvent(ITEM_GROUP).register(content -> {
            content.add(COMBAT_KNIFE);
        });
    }
}
