package me.unurled.lymel.mixin.server.Player;

import me.unurled.lymel.components.events.player.JoinServerCallback;
import me.unurled.lymel.components.events.player.LeaveServerCallback;
import net.minecraft.network.ClientConnection;
import net.minecraft.server.PlayerManager;
import net.minecraft.server.network.ServerPlayerEntity;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

@Mixin(PlayerManager.class)
public class PlayerManagerMixin {
    @Inject(method = "onPlayerConnect", at = @At(value = "TAIL"), cancellable = true)
    public void onJoin(ClientConnection connection, ServerPlayerEntity player, CallbackInfo ci) {
        JoinServerCallback.EVENT.invoker().join((PlayerManager) (Object) this, connection, player);
    }

    @Inject(method = "remove", at = @At(value = "HEAD"))
    public void onLeave(ServerPlayerEntity player, CallbackInfo ci) {
        LeaveServerCallback.EVENT.invoker().leave((PlayerManager) (Object) this, player);
    }
}
