package me.unurled.lymel.util;

import com.google.gson.Gson;
import com.google.gson.JsonParser;
import com.mojang.serialization.JsonOps;
import me.unurled.lymel.Lymel;
import net.minecraft.block.Material;
import net.minecraft.entity.player.PlayerEntity;
import net.minecraft.entity.player.PlayerInventory;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NbtCompound;
import net.minecraft.registry.Registries;
import net.minecraft.registry.entry.RegistryEntry;
import org.bson.Document;
import org.bson.conversions.Bson;

import java.util.Arrays;
import java.util.Base64;

public class EquipmentUtil {
    public static void updateStatuses(PlayerEntity player, ItemStack stack) {
        if (stack.hasNbt()) {
            String s = serelizeItemStack(stack);
            Lymel.LOGGER.info("nbt looooooooooooog " + s);
        }
    }

    static String serelizeItemStack(ItemStack stack) {
        var json = ItemStack.CODEC.encode(stack, JsonOps.INSTANCE, JsonOps.INSTANCE.empty());
        String string = "";
        Gson GSON = new Gson();
        if (json.result().isPresent()) {
            string = GSON.toJson(json.result().get());
        }
        return string;
    }

    static ItemStack deserilizeItemStack(String string) {
        var jsonDecoded = JsonParser.parseString(string);
        var stackDecoded = ItemStack.CODEC.decode(JsonOps.INSTANCE, jsonDecoded);
        if (stackDecoded.result().isPresent()) {
            return stackDecoded.result().get().getFirst();
        }
        return null;
    }

    static String encodeItem(ItemStack item) {
        String string = serelizeItemStack(item);
        return Base64.getEncoder().encodeToString(string.getBytes());
    }

    static ItemStack decodeString(String string) {
        var s = Arrays.toString(Base64.getDecoder().decode(string.getBytes()));
        return deserilizeItemStack(s);
    }

    public static String encodeInventory(PlayerInventory inv)  {
        StringBuilder string = new StringBuilder();
        for (int i = 0 ; i < inv.size() ; i++) {
            if (inv.getStack(i) != ItemStack.EMPTY) {
                string
                        .append(i)
                        .append(":")
                        .append(encodeItem(inv.getStack(i)))
                        .append("$");
            }
        }
        return string.toString();
    }

    public static PlayerInventory decodeInventory(PlayerEntity player, String strings) {
        PlayerInventory playerInventory = player.getInventory();
        if (strings.contains("\\$")) {
            String[] items = strings.split("\\$");
            for (String item : items) {
                String[] hehe = item.split(":");
                int i = Integer.parseInt(hehe[0]);
                ItemStack stack = decodeString(hehe[1]);
                if (stack != null) {
                    playerInventory.insertStack(i, stack);
                }
            }
        }
        return playerInventory;
    }
}
